/* frontend to IBE_decrypt() in ibe_lib.cc
 * (performs decryption)
 * Ben Lynn
 */

/*
Copyright (C) 2001 Benjamin Lynn (blynn@cs.stanford.edu)

This file is part of the Stanford IBE system.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/*
Copyright (C) 2001 Benjamin Lynn (blynn@cs.stanford.edu)

This file is part of the Stanford IBE system.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <openssl/evp.h>
#include <string.h>
#include "ibe.h"
#include "format.h"
#include "ibe_progs.h"

int decrypt(int argc, char **argv)
{
    char *privkeyfile = GetStringParam(cnfctx, "keyfile", 0, "keyfile");
    byte_string_t key;
    byte_string_t M;
    char pw[100];
    int status;

    status = EVP_read_pw_string(pw, 100, "private key password: ", 1);
    if (status) {
	fprintf(stderr, "error reading private key password\n");
	return 1;
    }
    status = FMT_crypt_load(privkeyfile, key, pw);
    if (status != 1) {
	fprintf(stderr, "error loading private key %s\n", privkeyfile);
	return 1;
    }

    status = FMT_decrypt(M, stdin, key);
    if (status != 1) {
	fprintf(stderr, "error in decryption\n");
	return 1;
    }

    byte_string_printf(M, "%c");
    return 0;
}
