/* frontend to IBE_encrypt() in ibe_lib.cc
 * (performs encryption)
 * Ben Lynn
 */

/*
Copyright (C) 2001 Benjamin Lynn (blynn@cs.stanford.edu)

This file is part of the Stanford IBE system.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdlib.h>
#include "format.h"
#include "ibe.h"

int encrypt(int argc, char **argv)
{
    byte_string_t M;
    char *id;
    unsigned char *buftemp;
    int pbufsize = 100;
    char *idarray[2];
    unsigned char *ptext;
    int ptextlen;

    if (argc < 2) {
	printf("Usage: encrypt ID\n\n");
	printf("Encrypts stdin and prints on stdout\n");
	return 1;
    }
    id = IBE_make_id(argv[1], NULL);

    ptext = (unsigned char *) malloc(pbufsize);

    ptextlen = 0;
    for(;;) {
	char ch;
	ch = getchar();
	if (feof(stdin)) break;
	ptext[ptextlen] = ch;
	ptextlen++;
	if (ptextlen >= pbufsize) {
	    pbufsize *= 2;
	    buftemp = (unsigned char *) malloc(pbufsize);
	    memcpy(buftemp, ptext, ptextlen);
	    free(ptext);
	    ptext = buftemp;
	}
    }

    //fprintf(stderr, "Encrypting...\n");
    idarray[0] = id;
    idarray[1] = NULL;

    M->data = ptext;
    M->len = ptextlen;

/*
printf("Encrypting...\n");
byte_string_printf(M, "%c");
printf("\n");
*/
    printf("\n-----BEGIN IBE-----\n");
    FMT_encrypt(stdout, M, idarray);
    printf("-----END IBE-----\n");
    byte_string_clear(M);

    return 0;
}
