//fp2 sanity checks
#include "fp2.h"

int p = 59;

void fp2_random(fp2_ptr r)
//r = random element of F_p^2
{
    mpz_set_ui(r->a, random() % p);
    mpz_set_ui(r->b, random() % p);
}

int main(int argc, char **argv)
{
    mpz_t m;
    fp2_t a, b, c;

    if (argc > 1) sscanf(argv[1], "%d", &p);

    mpz_init_set_ui(m, p);
    mpz_out_str(NULL, 0, m);
    printf(" = %d\n", p);
    fp2_init_modulus(m);

    fp2_init(a);
    fp2_init(b);
    fp2_init(c);

    fp2_random(a);
    fp2_random(b);

    printf("a b = ");
    fp2_out_str(NULL, 0, a);
    printf(" ");
    fp2_out_str(NULL, 0, b);
    printf("\n");

    fp2_add(c, a, b);
    fp2_sub(c, c, a);
    fp2_sub(c, c, b);

    printf("0 = ");
    fp2_out_str(NULL, 0, c);
    printf("\n");

    fp2_inv(c, a);
    fp2_inv(c, c);
    printf("a = ");
    fp2_out_str(NULL, 0, c);
    printf("\n");

    fp2_inv(c, a);
    fp2_mul(c, c, a);
    printf("1 = ");
    fp2_out_str(NULL, 0, c);
    printf("\n");

    fp2_pow(c, c, m);
    printf("1 = ");
    fp2_out_str(NULL, 0, c);
    printf("\n");

    fp2_pow(c, a, m);
    fp2_pow(c, c, m);
    printf("a = ");
    fp2_out_str(NULL, 0, c);
    printf("\n");

    fp2_shutdown();
    return 0;
}
